-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Data Editors - Right-to-Left Support
The DevExtreme Editor components support right-to-left (RTL) languages. The components can display content in a right-to-left direction and mirror associated UI elements.
Backend API
$(() => {
const checkBoxWidget = $('#checkbox').dxCheckBox({
value: true,
text: 'text',
elementAttr: { 'aria-label': 'Language' },
}).dxCheckBox('instance');
const switchWidget = $('#switch').dxSwitch({}).dxSwitch('instance');
const textBoxWidget = $('#text-box').dxTextBox({
showClearButton: true,
inputAttr: { 'aria-label': 'Text Box' },
value: 'text',
}).dxTextBox('instance');
const numberBoxWidget = $('#number-box').dxNumberBox({
showSpinButtons: true,
value: '123',
inputAttr: { 'aria-label': 'Number Box' },
}).dxNumberBox('instance');
const selectBoxWidget = $('#select-box').dxSelectBox({
items: europeanUnion,
inputAttr: { 'aria-label': 'European Union' },
value: europeanUnion[0].id,
displayExpr: 'nameEn',
valueExpr: 'id',
}).dxSelectBox('instance');
const tagBoxWidget = $('#tag-box').dxTagBox({
items: europeanUnion,
value: [europeanUnion[0].id],
placeholder: '...',
displayExpr: 'nameEn',
inputAttr: { 'aria-label': 'Name' },
valueExpr: 'id',
}).dxTagBox('instance');
const textAreaWidget = $('#text-area').dxTextArea({
value: 'text',
inputAttr: { 'aria-label': 'Notes' },
}).dxTextArea('instance');
const autocompleteWidget = $('#autocomplete').dxAutocomplete({
items: europeanUnion,
valueExpr: 'nameEn',
inputAttr: { 'aria-label': 'Autocomplete' },
}).dxAutocomplete('instance');
const languages = ['Arabic: Right-to-Left direction', 'English: Left-to-Right direction'];
$('#select-language').dxSelectBox({
items: languages,
inputAttr: { 'aria-label': 'Language' },
value: languages[1],
onValueChanged(data) {
const rtl = data.value === languages[0];
const text = rtl ? 'نص' : 'text';
const expression = rtl ? 'nameAr' : 'nameEn';
$('#form').toggleClass('dx-rtl', rtl);
checkBoxWidget.option({
text,
rtlEnabled: rtl,
});
textBoxWidget.option({
value: text,
rtlEnabled: rtl,
});
textAreaWidget.option({
value: text,
rtlEnabled: rtl,
});
selectBoxWidget.option({
displayExpr: expression,
rtlEnabled: rtl,
});
tagBoxWidget.option({
displayExpr: expression,
rtlEnabled: rtl,
});
autocompleteWidget.option({
value: '',
rtlEnabled: rtl,
});
autocompleteWidget.option({
valueExpr: expression,
rtlEnabled: rtl,
});
numberBoxWidget.option('rtlEnabled', rtl);
switchWidget.option('rtlEnabled', rtl);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.3"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="form">
<div class="options">
<div class="caption">Options</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Language</div>
<div class="dx-field-value">
<div id="select-language"></div>
</div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Text Box</div>
<div class="dx-field-value">
<div id="text-box"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Number Box</div>
<div class="dx-field-value">
<div id="number-box"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Select Box</div>
<div class="dx-field-value">
<div id="select-box"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Tag Box</div>
<div class="dx-field-value">
<div id="tag-box"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Text Area</div>
<div class="dx-field-value">
<div id="text-area"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Autocomplete</div>
<div class="dx-field-value">
<div id="autocomplete"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Check Box</div>
<div class="dx-field-value">
<div id="checkbox"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Switch</div>
<div class="dx-field-value">
<div id="switch"></div>
</div>
</div>
</div>
</div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.options .dx-fieldset {
margin: 0;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
const europeanUnion = [{
id: 1,
nameAr: 'النمسا',
nameEn: 'Austria',
}, {
id: 2,
nameAr: 'بلجيكا',
nameEn: 'Belgium',
}, {
id: 3,
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
}, {
id: 4,
nameAr: 'كرواتيا',
nameEn: 'Croatia',
}, {
id: 5,
nameAr: 'قبرص',
nameEn: 'Cyprus',
}, {
id: 6,
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
}, {
id: 7,
nameAr: 'الدنمارك',
nameEn: 'Denmark',
}, {
id: 8,
nameAr: 'استونيا',
nameEn: 'Estonia',
}, {
id: 9,
nameAr: 'فنلندا',
nameEn: 'Finland',
}, {
id: 10,
nameAr: 'فرنسا',
nameEn: 'France',
}, {
id: 11,
nameAr: 'ألمانيا',
nameEn: 'Germany',
}, {
id: 12,
nameAr: 'يونان',
nameEn: 'Greece',
}, {
id: 13,
nameAr: 'هنغاريا',
nameEn: 'Hungary',
}, {
id: 14,
nameAr: 'أيرلندا',
nameEn: 'Ireland',
}, {
id: 15,
nameAr: 'إيطاليا',
nameEn: 'Italy',
}, {
id: 16,
nameAr: 'لاتفيا',
nameEn: 'Latvia',
}, {
id: 17,
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
}, {
id: 18,
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
}, {
id: 19,
nameAr: 'مالطا',
nameEn: 'Malta',
}, {
id: 20,
nameAr: 'هولندا',
nameEn: 'Netherlands',
}, {
id: 21,
nameAr: 'بولندا',
nameEn: 'Poland',
}, {
id: 22,
nameAr: 'البرتغال',
nameEn: 'Portugal',
}, {
id: 23,
nameAr: 'رومانيا',
nameEn: 'Romania',
}, {
id: 24,
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
}, {
id: 25,
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
}, {
id: 26,
nameAr: 'إسبانيا',
nameEn: 'Spain',
}, {
id: 27,
nameAr: 'السويد',
nameEn: 'Sweden',
}, {
id: 28,
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
}];
To enable RTL language support in the application, you can either set the globalConfig object's rtlEnabled property to true or specify each component's rtlEnabled property individually. Note that individual RTL parameters have higher priority than general parameters.
In this demo, you can use the language drop-down menu (for example, change the language from English to Arabic) to explore the differences between default and RTL modes.

Backend API
<div [class]="{ 'dx-rtl': rtlEnabled }">
<div class="options">
<div class="caption">Options</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Language</div>
<div class="dx-field-value">
<dx-select-box
[items]="languages"
[inputAttr]="{ 'aria-label': 'Language' }"
[value]="languages[1]"
[rtlEnabled]="rtlEnabled"
(onValueChanged)="onLanguageChanged($event)"
></dx-select-box>
</div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Text Box</div>
<div class="dx-field-value">
<dx-text-box
[showClearButton]="true"
[inputAttr]="{ 'aria-label': 'Text Box' }"
[value]="textValue"
[rtlEnabled]="rtlEnabled"
>
</dx-text-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Number Box</div>
<div class="dx-field-value">
<dx-number-box
[showSpinButtons]="true"
[value]="123"
[rtlEnabled]="rtlEnabled"
[inputAttr]="{ 'aria-label': 'Number Box' }"
>
</dx-number-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Select Box</div>
<div class="dx-field-value">
<dx-select-box
[items]="europeanUnion"
[inputAttr]="{ 'aria-label': 'European Union Data' }"
[value]="europeanUnion[0]"
[displayExpr]="displayExpr"
[rtlEnabled]="rtlEnabled"
>
</dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Tag Box</div>
<div class="dx-field-value">
<dx-tag-box
[items]="europeanUnion"
[value]="[europeanUnion[0].id]"
placeholder="..."
valueExpr="id"
[inputAttr]="{ 'aria-label': 'Name' }"
[displayExpr]="displayExpr"
[rtlEnabled]="rtlEnabled"
></dx-tag-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Text Area</div>
<div class="dx-field-value">
<dx-text-area
[value]="textValue"
[rtlEnabled]="rtlEnabled"
[inputAttr]="{ 'aria-label': 'Notes' }"
>
</dx-text-area>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Autocomplete</div>
<div class="dx-field-value">
<dx-autocomplete
[items]="europeanUnion"
[valueExpr]="displayExpr"
[rtlEnabled]="rtlEnabled"
[inputAttr]="{ 'aria-label': 'Autocomplete' }"
>
</dx-autocomplete>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Check Box</div>
<div class="dx-field-value">
<dx-check-box
[value]="true"
[text]="textValue"
[rtlEnabled]="rtlEnabled"
>
</dx-check-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Switch</div>
<div class="dx-field-value">
<dx-switch [rtlEnabled]="rtlEnabled"></dx-switch>
</div>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxSelectBoxModule,
DxCheckBoxModule,
DxTextBoxModule,
DxTextAreaModule,
DxNumberBoxModule,
DxTagBoxModule,
DxSwitchModule,
DxAutocompleteModule,
} from 'devextreme-angular';
import { Service, Country } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxSelectBoxModule,
DxAutocompleteModule,
DxCheckBoxModule,
DxSwitchModule,
DxTextAreaModule,
DxTextBoxModule,
DxNumberBoxModule,
DxTagBoxModule,
],
})
export class AppComponent {
languages: string[] = [
'Arabic: Right-to-Left direction',
'English: Left-to-Right direction',
];
displayExpr = 'nameEn';
rtlEnabled = false;
textValue = 'text';
europeanUnion: Country[];
constructor(service: Service) {
this.europeanUnion = service.getCountries();
}
onLanguageChanged(data) {
const isRTL = data.value === this.languages[0];
this.displayExpr = isRTL ? 'nameAr' : 'nameEn';
this.rtlEnabled = isRTL;
this.textValue = isRTL ? 'نص' : 'text';
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .options .dx-fieldset {
margin: 0;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
.option > span {
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export class Country {
id: number;
nameAr: string;
nameEn: string;
}
const europeanUnion: Country[] = [{
id: 1,
nameAr: 'النمسا',
nameEn: 'Austria',
}, {
id: 2,
nameAr: 'بلجيكا',
nameEn: 'Belgium',
}, {
id: 3,
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
}, {
id: 4,
nameAr: 'كرواتيا',
nameEn: 'Croatia',
}, {
id: 5,
nameAr: 'قبرص',
nameEn: 'Cyprus',
}, {
id: 6,
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
}, {
id: 7,
nameAr: 'الدنمارك',
nameEn: 'Denmark',
}, {
id: 8,
nameAr: 'استونيا',
nameEn: 'Estonia',
}, {
id: 9,
nameAr: 'فنلندا',
nameEn: 'Finland',
}, {
id: 10,
nameAr: 'فرنسا',
nameEn: 'France',
}, {
id: 11,
nameAr: 'ألمانيا',
nameEn: 'Germany',
}, {
id: 12,
nameAr: 'يونان',
nameEn: 'Greece',
}, {
id: 13,
nameAr: 'هنغاريا',
nameEn: 'Hungary',
}, {
id: 14,
nameAr: 'أيرلندا',
nameEn: 'Ireland',
}, {
id: 15,
nameAr: 'إيطاليا',
nameEn: 'Italy',
}, {
id: 16,
nameAr: 'لاتفيا',
nameEn: 'Latvia',
}, {
id: 17,
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
}, {
id: 18,
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
}, {
id: 19,
nameAr: 'مالطا',
nameEn: 'Malta',
}, {
id: 20,
nameAr: 'هولندا',
nameEn: 'Netherlands',
}, {
id: 21,
nameAr: 'بولندا',
nameEn: 'Poland',
}, {
id: 22,
nameAr: 'البرتغال',
nameEn: 'Portugal',
}, {
id: 23,
nameAr: 'رومانيا',
nameEn: 'Romania',
}, {
id: 24,
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
}, {
id: 25,
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
}, {
id: 26,
nameAr: 'إسبانيا',
nameEn: 'Spain',
}, {
id: 27,
nameAr: 'السويد',
nameEn: 'Sweden',
}, {
id: 28,
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
},
];
@Injectable()
export class Service {
getCountries(): Country[] {
return europeanUnion;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.66',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.66/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.5/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
To enable RTL language support in the application, you can either set the globalConfig object's rtlEnabled property to true or specify each component's rtlEnabled property individually. Note that individual RTL parameters have higher priority than general parameters.
In this demo, you can use the language drop-down menu (for example, change the language from English to Arabic) to explore the differences between default and RTL modes.

Backend API
<template>
<div>
<div
:class="{ 'dx-rtl': rtlEnabled }"
>
<div class="options">
<div class="caption">Options</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Language</div>
<div class="dx-field-value">
<DxSelectBox
:items="languages"
:input-attr="{ 'aria-label': 'Language' }"
:value="languages[1]"
:rtl-enabled="rtlEnabled"
@valueChanged="onLanguageChanged"
/>
</div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Text Box</div>
<div class="dx-field-value">
<DxTextBox
:show-clear-button="true"
:value="textValue"
:input-attr="{ 'aria-label': 'Text Box' }"
:rtl-enabled="rtlEnabled"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Number Box</div>
<div class="dx-field-value">
<DxNumberBox
:show-spin-buttons="true"
:value="123"
:rtl-enabled="rtlEnabled"
:input-attr="{ 'aria-label': 'Number Box' }"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Select Box</div>
<div class="dx-field-value">
<DxSelectBox
:items="europeanUnion"
:value="europeanUnion[0]"
:input-attr="{ 'aria-label': 'European Union Data' }"
:rtl-enabled="rtlEnabled"
:display-expr="displayExpr"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Tag Box</div>
<div class="dx-field-value">
<DxTagBox
:items="europeanUnion"
:value="[europeanUnion[0].id]"
:input-attr="{ 'aria-label': 'Name' }"
:rtl-enabled="rtlEnabled"
:display-expr="displayExpr"
placeholder="..."
value-expr="id"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Text Area</div>
<div class="dx-field-value">
<DxTextArea
:value="textValue"
:rtl-enabled="rtlEnabled"
:input-attr="{ 'aria-label': 'Notes' }"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Autocomplete</div>
<div class="dx-field-value">
<DxAutocomplete
:items="europeanUnion"
:rtl-enabled="rtlEnabled"
:value-expr="displayExpr"
:input-attr="{ 'aria-label': 'Autocomplete' }"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Check Box</div>
<div class="dx-field-value">
<DxCheckBox
:value="true"
:text="textValue"
:rtl-enabled="rtlEnabled"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Switch</div>
<div class="dx-field-value">
<DxSwitch
:rtl-enabled="rtlEnabled"
/>
</div>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import DxAutocomplete from 'devextreme-vue/autocomplete';
import DxCheckBox from 'devextreme-vue/check-box';
import DxSwitch from 'devextreme-vue/switch';
import DxTextArea from 'devextreme-vue/text-area';
import DxTextBox from 'devextreme-vue/text-box';
import DxNumberBox from 'devextreme-vue/number-box';
import DxTagBox from 'devextreme-vue/tag-box';
import { europeanUnion as europeanUnionData } from './data.ts';
const languages = [
'Arabic: Right-to-Left direction',
'English: Left-to-Right direction',
];
const europeanUnion = ref(europeanUnionData);
const displayExpr = ref('nameEn');
const rtlEnabled = ref(false);
const textValue = ref('text');
function onLanguageChanged(args: DxSelectBoxTypes.ValueChangedEvent) {
const isRTL = args.value === languages[0];
displayExpr.value = isRTL ? 'nameAr' : 'nameEn';
rtlEnabled.value = isRTL;
textValue.value = isRTL ? 'نص' : 'text';
}
</script>
<style>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.options .dx-fieldset {
margin: 0;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const europeanUnion = [{
id: 1,
nameAr: 'النمسا',
nameEn: 'Austria',
}, {
id: 2,
nameAr: 'بلجيكا',
nameEn: 'Belgium',
}, {
id: 3,
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
}, {
id: 4,
nameAr: 'كرواتيا',
nameEn: 'Croatia',
}, {
id: 5,
nameAr: 'قبرص',
nameEn: 'Cyprus',
}, {
id: 6,
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
}, {
id: 7,
nameAr: 'الدنمارك',
nameEn: 'Denmark',
}, {
id: 8,
nameAr: 'استونيا',
nameEn: 'Estonia',
}, {
id: 9,
nameAr: 'فنلندا',
nameEn: 'Finland',
}, {
id: 10,
nameAr: 'فرنسا',
nameEn: 'France',
}, {
id: 11,
nameAr: 'ألمانيا',
nameEn: 'Germany',
}, {
id: 12,
nameAr: 'يونان',
nameEn: 'Greece',
}, {
id: 13,
nameAr: 'هنغاريا',
nameEn: 'Hungary',
}, {
id: 14,
nameAr: 'أيرلندا',
nameEn: 'Ireland',
}, {
id: 15,
nameAr: 'إيطاليا',
nameEn: 'Italy',
}, {
id: 16,
nameAr: 'لاتفيا',
nameEn: 'Latvia',
}, {
id: 17,
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
}, {
id: 18,
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
}, {
id: 19,
nameAr: 'مالطا',
nameEn: 'Malta',
}, {
id: 20,
nameAr: 'هولندا',
nameEn: 'Netherlands',
}, {
id: 21,
nameAr: 'بولندا',
nameEn: 'Poland',
}, {
id: 22,
nameAr: 'البرتغال',
nameEn: 'Portugal',
}, {
id: 23,
nameAr: 'رومانيا',
nameEn: 'Romania',
}, {
id: 24,
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
}, {
id: 25,
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
}, {
id: 26,
nameAr: 'إسبانيا',
nameEn: 'Spain',
}, {
id: 27,
nameAr: 'السويد',
nameEn: 'Sweden',
}, {
id: 28,
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
import React, { useCallback, useState } from 'react';
import { NumberBox } from 'devextreme-react/number-box';
import { SelectBox } from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import { Switch } from 'devextreme-react/switch';
import { TextBox } from 'devextreme-react/text-box';
import { Autocomplete } from 'devextreme-react/autocomplete';
import { CheckBox } from 'devextreme-react/check-box';
import { TextArea } from 'devextreme-react/text-area';
import { TagBox } from 'devextreme-react/tag-box';
import {
europeanUnion,
numberBoxLabel,
notesLabel,
nameLabel,
textBoxLabel,
europeanUnionDataLabel,
languageLabel,
autocompleteLabel,
} from './data.ts';
const languages: string[] = ['Arabic: Right-to-Left direction', 'English: Left-to-Right direction'];
const tagBoxDefaultValue: number[] = [europeanUnion[0].id];
function App() {
const [rtlEnabled, setRtlEnabled] = useState<boolean>(false);
const [displayExpr, setDisplayExpr] = useState<string>('nameEn');
const [textValue, setTextValue] = useState<string>('text');
const onLanguageChanged = useCallback((args: SelectBoxTypes.ValueChangedEvent): void => {
const isRTL = args.value === languages[0];
setDisplayExpr(isRTL ? 'nameAr' : 'nameEn');
setRtlEnabled(isRTL);
setTextValue(isRTL ? 'نص' : 'text');
}, []);
return (
<div>
<div className={rtlEnabled ? 'dx-rtl' : undefined}>
<div className="options">
<div className="caption">Options</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Language</div>
<div className="dx-field-value">
<SelectBox
items={languages}
inputAttr={languageLabel}
defaultValue={languages[1]}
rtlEnabled={rtlEnabled}
onValueChanged={onLanguageChanged}
/>
</div>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Text Box</div>
<div className="dx-field-value">
<TextBox
showClearButton={true}
inputAttr={textBoxLabel}
defaultValue={textValue}
rtlEnabled={rtlEnabled}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Number Box</div>
<div className="dx-field-value">
<NumberBox
showSpinButtons={true}
defaultValue={123}
rtlEnabled={rtlEnabled}
inputAttr={numberBoxLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Select Box</div>
<div className="dx-field-value">
<SelectBox
items={europeanUnion}
inputAttr={europeanUnionDataLabel}
defaultValue={europeanUnion[0]}
rtlEnabled={rtlEnabled}
displayExpr={displayExpr}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Tag Box</div>
<div className="dx-field-value">
<TagBox
items={europeanUnion}
defaultValue={tagBoxDefaultValue}
rtlEnabled={rtlEnabled}
inputAttr={nameLabel}
displayExpr={displayExpr}
placeholder="..."
valueExpr="id"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Text Area</div>
<div className="dx-field-value">
<TextArea
defaultValue={textValue}
rtlEnabled={rtlEnabled}
inputAttr={notesLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Autocomplete</div>
<div className="dx-field-value">
<Autocomplete
items={europeanUnion}
rtlEnabled={rtlEnabled}
valueExpr={displayExpr}
inputAttr={autocompleteLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Check Box</div>
<div className="dx-field-value">
<CheckBox
defaultValue={true}
text={textValue}
rtlEnabled={rtlEnabled}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Switch</div>
<div className="dx-field-value">
<Switch rtlEnabled={rtlEnabled} />
</div>
</div>
</div>
</div>
</div>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import { NumberBox } from 'devextreme-react/number-box';
import { SelectBox } from 'devextreme-react/select-box';
import { Switch } from 'devextreme-react/switch';
import { TextBox } from 'devextreme-react/text-box';
import { Autocomplete } from 'devextreme-react/autocomplete';
import { CheckBox } from 'devextreme-react/check-box';
import { TextArea } from 'devextreme-react/text-area';
import { TagBox } from 'devextreme-react/tag-box';
import {
europeanUnion,
numberBoxLabel,
notesLabel,
nameLabel,
textBoxLabel,
europeanUnionDataLabel,
languageLabel,
autocompleteLabel,
} from './data.js';
const languages = ['Arabic: Right-to-Left direction', 'English: Left-to-Right direction'];
const tagBoxDefaultValue = [europeanUnion[0].id];
function App() {
const [rtlEnabled, setRtlEnabled] = useState(false);
const [displayExpr, setDisplayExpr] = useState('nameEn');
const [textValue, setTextValue] = useState('text');
const onLanguageChanged = useCallback((args) => {
const isRTL = args.value === languages[0];
setDisplayExpr(isRTL ? 'nameAr' : 'nameEn');
setRtlEnabled(isRTL);
setTextValue(isRTL ? 'نص' : 'text');
}, []);
return (
<div>
<div className={rtlEnabled ? 'dx-rtl' : undefined}>
<div className="options">
<div className="caption">Options</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Language</div>
<div className="dx-field-value">
<SelectBox
items={languages}
inputAttr={languageLabel}
defaultValue={languages[1]}
rtlEnabled={rtlEnabled}
onValueChanged={onLanguageChanged}
/>
</div>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Text Box</div>
<div className="dx-field-value">
<TextBox
showClearButton={true}
inputAttr={textBoxLabel}
defaultValue={textValue}
rtlEnabled={rtlEnabled}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Number Box</div>
<div className="dx-field-value">
<NumberBox
showSpinButtons={true}
defaultValue={123}
rtlEnabled={rtlEnabled}
inputAttr={numberBoxLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Select Box</div>
<div className="dx-field-value">
<SelectBox
items={europeanUnion}
inputAttr={europeanUnionDataLabel}
defaultValue={europeanUnion[0]}
rtlEnabled={rtlEnabled}
displayExpr={displayExpr}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Tag Box</div>
<div className="dx-field-value">
<TagBox
items={europeanUnion}
defaultValue={tagBoxDefaultValue}
rtlEnabled={rtlEnabled}
inputAttr={nameLabel}
displayExpr={displayExpr}
placeholder="..."
valueExpr="id"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Text Area</div>
<div className="dx-field-value">
<TextArea
defaultValue={textValue}
rtlEnabled={rtlEnabled}
inputAttr={notesLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Autocomplete</div>
<div className="dx-field-value">
<Autocomplete
items={europeanUnion}
rtlEnabled={rtlEnabled}
valueExpr={displayExpr}
inputAttr={autocompleteLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Check Box</div>
<div className="dx-field-value">
<CheckBox
defaultValue={true}
text={textValue}
rtlEnabled={rtlEnabled}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Switch</div>
<div className="dx-field-value">
<Switch rtlEnabled={rtlEnabled} />
</div>
</div>
</div>
</div>
</div>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
import type { EuropeanUnionCountries } from './types.ts';
export const europeanUnion: EuropeanUnionCountries[] = [{
id: 1,
nameAr: 'النمسا',
nameEn: 'Austria',
}, {
id: 2,
nameAr: 'بلجيكا',
nameEn: 'Belgium',
}, {
id: 3,
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
}, {
id: 4,
nameAr: 'كرواتيا',
nameEn: 'Croatia',
}, {
id: 5,
nameAr: 'قبرص',
nameEn: 'Cyprus',
}, {
id: 6,
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
}, {
id: 7,
nameAr: 'الدنمارك',
nameEn: 'Denmark',
}, {
id: 8,
nameAr: 'استونيا',
nameEn: 'Estonia',
}, {
id: 9,
nameAr: 'فنلندا',
nameEn: 'Finland',
}, {
id: 10,
nameAr: 'فرنسا',
nameEn: 'France',
}, {
id: 11,
nameAr: 'ألمانيا',
nameEn: 'Germany',
}, {
id: 12,
nameAr: 'يونان',
nameEn: 'Greece',
}, {
id: 13,
nameAr: 'هنغاريا',
nameEn: 'Hungary',
}, {
id: 14,
nameAr: 'أيرلندا',
nameEn: 'Ireland',
}, {
id: 15,
nameAr: 'إيطاليا',
nameEn: 'Italy',
}, {
id: 16,
nameAr: 'لاتفيا',
nameEn: 'Latvia',
}, {
id: 17,
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
}, {
id: 18,
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
}, {
id: 19,
nameAr: 'مالطا',
nameEn: 'Malta',
}, {
id: 20,
nameAr: 'هولندا',
nameEn: 'Netherlands',
}, {
id: 21,
nameAr: 'بولندا',
nameEn: 'Poland',
}, {
id: 22,
nameAr: 'البرتغال',
nameEn: 'Portugal',
}, {
id: 23,
nameAr: 'رومانيا',
nameEn: 'Romania',
}, {
id: 24,
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
}, {
id: 25,
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
}, {
id: 26,
nameAr: 'إسبانيا',
nameEn: 'Spain',
}, {
id: 27,
nameAr: 'السويد',
nameEn: 'Sweden',
}, {
id: 28,
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
}];
export const numberBoxLabel = { 'aria-label': 'Number Box' };
export const notesLabel = { 'aria-label': 'Notes' };
export const nameLabel = { 'aria-label': 'Name' };
export const dateLabel = { 'aria-label': 'Date' };
export const textBoxLabel = { 'aria-label': 'Text Box' };
export const passwordLabel = { 'aria-label': 'Password' };
export const maskLabel = { 'aria-label': 'Mask' };
export const emailLabel = { 'aria-label': 'Email' };
export const cityLabel = { 'aria-label': 'City' };
export const addressLabel = { 'aria-label': 'Address' };
export const languageLabel = { 'aria-label': 'Language' };
export const europeanUnionDataLabel = { 'aria-label': 'European Union Data' };
export const autocompleteLabel = { 'aria-label': 'Autocomplete' };
export type EuropeanUnionCountries = {
id: number,
nameAr: string,
nameEn: string,
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const europeanUnion = [
{
id: 1,
nameAr: 'النمسا',
nameEn: 'Austria',
},
{
id: 2,
nameAr: 'بلجيكا',
nameEn: 'Belgium',
},
{
id: 3,
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
},
{
id: 4,
nameAr: 'كرواتيا',
nameEn: 'Croatia',
},
{
id: 5,
nameAr: 'قبرص',
nameEn: 'Cyprus',
},
{
id: 6,
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
},
{
id: 7,
nameAr: 'الدنمارك',
nameEn: 'Denmark',
},
{
id: 8,
nameAr: 'استونيا',
nameEn: 'Estonia',
},
{
id: 9,
nameAr: 'فنلندا',
nameEn: 'Finland',
},
{
id: 10,
nameAr: 'فرنسا',
nameEn: 'France',
},
{
id: 11,
nameAr: 'ألمانيا',
nameEn: 'Germany',
},
{
id: 12,
nameAr: 'يونان',
nameEn: 'Greece',
},
{
id: 13,
nameAr: 'هنغاريا',
nameEn: 'Hungary',
},
{
id: 14,
nameAr: 'أيرلندا',
nameEn: 'Ireland',
},
{
id: 15,
nameAr: 'إيطاليا',
nameEn: 'Italy',
},
{
id: 16,
nameAr: 'لاتفيا',
nameEn: 'Latvia',
},
{
id: 17,
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
},
{
id: 18,
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
},
{
id: 19,
nameAr: 'مالطا',
nameEn: 'Malta',
},
{
id: 20,
nameAr: 'هولندا',
nameEn: 'Netherlands',
},
{
id: 21,
nameAr: 'بولندا',
nameEn: 'Poland',
},
{
id: 22,
nameAr: 'البرتغال',
nameEn: 'Portugal',
},
{
id: 23,
nameAr: 'رومانيا',
nameEn: 'Romania',
},
{
id: 24,
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
},
{
id: 25,
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
},
{
id: 26,
nameAr: 'إسبانيا',
nameEn: 'Spain',
},
{
id: 27,
nameAr: 'السويد',
nameEn: 'Sweden',
},
{
id: 28,
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
},
];
export const numberBoxLabel = { 'aria-label': 'Number Box' };
export const notesLabel = { 'aria-label': 'Notes' };
export const nameLabel = { 'aria-label': 'Name' };
export const dateLabel = { 'aria-label': 'Date' };
export const textBoxLabel = { 'aria-label': 'Text Box' };
export const passwordLabel = { 'aria-label': 'Password' };
export const maskLabel = { 'aria-label': 'Mask' };
export const emailLabel = { 'aria-label': 'Email' };
export const cityLabel = { 'aria-label': 'City' };
export const addressLabel = { 'aria-label': 'Address' };
export const languageLabel = { 'aria-label': 'Language' };
export const europeanUnionDataLabel = { 'aria-label': 'European Union Data' };
export const autocompleteLabel = { 'aria-label': 'Autocomplete' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.options .dx-fieldset {
margin: 0;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}